package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/bg.png")] public static var ImgBg:Class;
		[Embed(source = "data/copper.png")] public static var ImgCopper:Class;
		[Embed(source = "data/people.png")] public static var ImgPeople:Class;
		[Embed(source = "data/targetsquare.png")] public static var ImgTarget:Class;
		[Embed(source = "data/emptytile.png")] public static var ImgEmptyTile:Class;
		
		public static var size : int = 11;
		public static var innersize : int = 3;
		
		public var board:FlxGroup;
		
		public var box:Box;
		public var initbox:Box;
		public var leftmargin:int=56;
		public var topmargin:int=16;
		
		public var won:Boolean;
		public var restarttext:FlxText;
		
		override public function create() : void
		{
			switch (FlxG.level)
			{
				case 0:
					size=4;
					innersize=2;
					break;
				case 1:
					size=4;
					innersize=3;
					break;
				case 2:
					size=5;
					innersize=4;
					break;
				case 3:
					size=5;
					innersize=3;
					break;
				case 4:
					size=6;
					innersize=3;
					break;
				case 5:
					size=6;
					innersize=4;
					break;
				case 6:
					size=7;
					innersize=4;
					break;
				case 7:
					size=8;
					innersize=5;
					break;
				case 8:
					size=9;
					innersize=5;
					break;
				case 9:
					size=10;
					innersize=5;
					break;
				case 10:
					size=11;
					innersize=5;
					break;
				case 11:
					size=11;
					innersize=6;
					break;
					
			}
			
			leftmargin=FlxG.width/2-19*(size/2);
			topmargin=FlxG.height/2-19*(size/2);
			
			
			won=false;
			super.create();
			
			var bg:FlxSprite = new FlxSprite(0,0,ImgBg);
			this.add(bg);
			
			for (i=0;i<size;i++)
			{
				for (j=0;j<size;j++)
				{
					s = new FlxSprite(leftmargin+19*i-1,topmargin+19*j-1,ImgEmptyTile);
					this.add(s);
				}
			}
			restarttext = new FlxText(0,0,FlxG.width,"press space to retry");
			restarttext.alignment="right";
			this.add(restarttext);
			var b:Box = Box.EndSquare(size,innersize);
			for (var i:int=0;i<b.dat.length;i++)
			{
				for (var j:int=0;j<b.dat.length;j++)
				{
					if (b.dat[i][j]>=0)
					{
						var s:FlxSprite = new FlxSprite(leftmargin+19*i,topmargin+19*j,ImgTarget);
						//s.createGraphic(16,16,0xffffff00);
						this.add(s);
					}
				}
			}
			board = new FlxGroup();
			this.add(board);
			generateBoard();	
			generateBoxGraphics();			
		}
		
		public function generateBoxGraphics() : void
		{
			board.kill();
			this.defaultGroup.remove(board);
			board = new FlxGroup();
			for (var i:int=0;i<box.dat.length;i++)
			{
				for (var j:int=0;j<box.dat[i].length;j++)
				{
					if (box.dat[i][j]>=0)
					{
						var s:FlxSprite = new FlxSprite(leftmargin+19*i,topmargin+19*j);
						s.loadGraphic(ImgPeople,true,false,18,18);
						s.addAnimation("1",[box.dat[i][j]]);
						s.play("1");
						//s.createGraphic(16,16,0xffffff00);
						board.add(s);
					}
				}
			}
			
			//draw cops
			
			var bounds:Vector.<int> = box.bounds();
			
			for (i=bounds[1]-1;i<=bounds[3]+1;i++)
			{
				for (j=bounds[0]-1;j<=bounds[2]+1;j++)
				{
					if (i==bounds[1]-1 || i==bounds[3]+1 || j==bounds[0]-1 || j==bounds[2]+1)
					{
						s = new FlxSprite(leftmargin+19*i,topmargin+19*j);
						s.loadGraphic(ImgCopper,true,false,18,18);
						s.addAnimation("1",[0]);
						s.play("1");
						board.add(s);
					}
				}
			}
			this.add(board);			
		}
	
		public function generateBoard() : void
		{
			box = Box.EndSquare(size,innersize);
			
			//generate action order
			var a:Vector.<int> = new Vector.<int>;
			
			for (var i:int=0;i<(size-innersize)/2;i++)
			{
				for (var j:int=0;j<4;j++)
				{
					a.push(j);
				}
			}
			
			a = MyMath.Permute(a);
			
			for (var k:int=0;k<a.length;k++)
			{
				box.print();
				//rotate n times
				for (j=0;j<a[k];j++)
				{
					box=Box.RotateL(box);
				}
				
				//calculate push
				
				//1: find leftmost lines									

				var leftmostindices:Vector.<int> = box.leftMostIndices();
				
				var lengthsToShunt:Vector.<int> = new Vector.<int>;
				for (i=0;i<leftmostindices.length;i++)
				{
					lengthsToShunt.push(MyMath.RndRange(0,box.clusterLength(leftmostindices[i])));
				}
		
				// perform the shunt
				for (i=0;i<leftmostindices.length;i++)
				{
					var row:int = leftmostindices[i];
					var left:int = box.clusterStartsAt(row);
					if (left==0)
						continue;
					var right:int = lengthsToShunt[i];
					
					box.dat[row][left-1]=Math.random()*6;
					box.dat[row][left+right]=-1;
				}
				
				// rotate back n times
				for (j=0;j<a[k];j++)
				{
					box=Box.RotateR(box);
				}
				
			}
			
			initbox = Box.Copy(box);			
		}
		public var t:Number;
		
		
		override public function update() : void
		{
			if (!won)
			{
				if (FlxG.keys.justPressed("UP"))
				{
					TryMoveBox(2);			
				}
				if (FlxG.keys.justPressed("RIGHT"))
				{
					TryMoveBox(3);		
				}
				if (FlxG.keys.justPressed("DOWN"))
				{
					TryMoveBox(0);			
				}
				if (FlxG.keys.justPressed("LEFT"))
				{
					TryMoveBox(1);		
				}
				if (FlxG.keys.justPressed("SPACE"))
				{
					ResetBox();
				}
			}
			else
			{
				
				if (t>0)
				{
					t-=FlxG.elapsed;
					if (t<0)
					{
						FlxG.level++;
						FlxG.state=new CutsceneState;
					}
				}
				
				if (FlxG.keys.justPressed("SPACE"))
				{
					s2.flicker(1);
					t=1;
				}				
			}
			
			super.update();
		}
		
		public function ResetBox():void
		{
			box = Box.Copy(initbox);
			generateBoxGraphics();
		}
		
		public var s2:FlxText;
		public function TryMoveBox(dir:int):void
		{
			box = Box.move(box,dir);
			generateBoxGraphics();
			if (box.victorious())
			{
				won=true;
				FlxG.play(TitleState.SndBlip);
				restarttext.visible=false;
				var s:FlxText = new FlxText(0,30,FlxG.width,"Area Secure");
				s.color=0xffe4fba0;
				s.alignment="center";
				s.size=32;
				this.add(s);
				s2 = new FlxText(0,200,FlxG.width,"press space to continue");
				s2.color=0xffe4fba0;
				s2.alignment="center";
				s2.size=8;
				this.add(s2);
				t=0;
			}
		}
			
	}
	
	

}

class Box {
	public var s : int;
	public var dat : Vector.<Vector.<int>>;
	public function Box(_s:int)
	{
		s=_s;
		dat = new Vector.<Vector.<int>>;
		
		for (var i:int =0;i<s;i++)
		{
			var v :Vector.<int> = new Vector.<int>;
			for (var j:int=0;j<s;j++)
			{
				v.push(-1);
			}
			dat.push(v);
		}
	}
	
	public function clusterLength(r:int):int//gets length of cluster on nth row(or column?)
	{
		var counter:int=0;
		for (var i:int=clusterStartsAt(r);i<dat[r].length;i++)
		{
			if (dat[r][i]>=0)
			{
				counter++;
			}
			else
			{
				break;
			}
		}
		
		return counter;
	}
	
	public function clusterStartsAt(r:int):int
	{
		for (var i:int=0;i<dat[r].length;i++)
		{
			if (dat[r][i]>=0)
				return i;
		}
		return -1;
	}
	
	public function leftMostPos():int
	{
		var min:int=100;
		for (var i:int=0;i<dat.length;i++)
		{
			var thismin : int = clusterStartsAt(i);
			if (thismin>=0 && thismin<min)
				min=thismin;
		}
		return min;
	}
	
	public function leftMostIndices():Vector.<int>
	{
		var min:int=leftMostPos();
		
		var leftmostindices:Vector.<int> = new Vector.<int>;
		for (var i:int=0;i<dat.length;i++)
		{
			if (clusterStartsAt(i)==min)
			{
				leftmostindices.push(i);
			}
		}
		return leftmostindices;
	}
	
	public function print():void
	{
		var s:String="";
		for (var i:int=0;i<this.dat.length;i++)
		{
			if (i>0)
				s+="\n";
			for (var j:int=0;j<this.dat.length;j++)
			{
				s+= this.dat[i][j]>=0?"X":".";				
			}
		}
		s+="\n\n";
		trace(s);
	}
	
	public function canpush(r:int):Boolean
	{
		for (var i:int=this.clusterStartsAt(r);i<this.s;i++)
		{
			if (dat[r][i]==-1)
				return true;
		}
		return false;
	}
	
	public function victorious():Boolean
	{
		var b:Box = Box.EndSquare(GameState.size,GameState.innersize);
		for (var i:int=0;i<b.dat.length;i++)
		{
			for (var j:int=0;j<b.dat[i].length;j++)
			{
				if ((b.dat[i][j]>=0)!=(this.dat[i][j]>=0))
					return false;					
			}
		}
		return true;		
	}
	
	public function bounds():Vector.<int>
	{
		var b:Box=this;
		var bounds : Vector.<int>= new Vector.<int>;
		for (var i:int=0;i<4;i++)
		{
			bounds.push(b.leftMostPos());
			b=Box.RotateL(b);
		}
		bounds[2]=b.s-1-bounds[2];
		bounds[1]=b.s-1-bounds[1];
		var t:int=bounds[1];
		bounds[1]=bounds[3];
		bounds[3]=t;
		return bounds;
	}
	
	public static function move(box:Box,dir:int):Box
	{
		var success:Boolean=true;
		for (var i:int=0;i<dir;i++)
		{
			box=Box.RotateL(box);
		}
		
		//do the pushing
		
		//1: find leftmost lines
		var leftmost:Vector.<int> = box.leftMostIndices();
		
		//2: check all can be pushed
		var canpush:Boolean = true;
		for (i=0;i<leftmost.length;i++) 
		{
			canpush &&= box.canpush(leftmost[i]);
		}
		
		//3: shunt right
		
		if (canpush)
		{
			for (i=0;i<leftmost.length;i++)
			{
				var row:int=leftmost[i];
				var left:int=box.clusterStartsAt(row);
				var w:int=box.clusterLength(row);
				for (var j:int=left+w;j>left;j--)
				{
					box.dat[row][j]=box.dat[row][j-1];
				}
				box.dat[row][left]=-1;
				//box.dat[row][left+w]=Math.random()*6;
			}
		}
		else
		{
			success=false;
		}
		
		for (i=0;i<dir;i++)
		{
			box=Box.RotateR(box);
		}
		
		return box;
	}
	
	public static function RotateL(b:Box):Box
	{
		var br:Box = new Box(b.s);
		for (var i:int=0;i<b.s;i++)
		{
			for (var j:int=0;j<b.s;j++)
			{
				br.dat[i][j]=b.dat[b.s-1-j][i];
			}
		}
		
		return br;
	}
	
	
	public static function RotateR(b:Box):Box
	{
		return Box.RotateL(Box.RotateL(Box.RotateL(b)));
	}
	
	public static function EndSquare(size:int, innersize:int):Box
	{
		var b:Box = new Box(size);
		var l:int = (size-innersize)/2;
		for (var i:int=0;i<innersize;i++)
		{
			for (var j:int=0;j<innersize;j++)
			{
				b.dat[l+i][l+j]=Math.random()*6;
			}
		}
		return b;
	}
	
	public static function Copy(b:Box):Box
	{
		var newb:Box = new Box(b.s);
		for (var i:int=0;i<b.s;i++)
		{
			for (var j:int=0;j<b.s;j++)
			{
				newb.dat[i][j]=b.dat[i][j];
			}
		}
		return newb;
	}
}

class MyMath
{
	public static function RndRange(a:int,b:int):int
	{
		return a+Math.random()*(b-a);
	}
	
	//warning - kills a right now
	public static function Permute(a:Vector.<int>):Vector.<int>
	{
		var ra:Vector.<int> =  new Vector.<int>;
		
		while (a.length>0)
		{
			var r:int = MyMath.RndRange(0,a.length);
			var n:int = a[r];
			a.splice(r,1);
			ra.push(n);
		}
		return ra;
	}
}